#!/usr/bin/perl -w

require '/var/smoothwall/header.pl';

my %cgiparams;

@shortmonths = ( "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug",
	"Sep", "Oct", "Nov", "December" );
@longmonths = ( "January", "Februrary", "March", "April", "May", "June",
	"July", "August", "September", "October", "November", "December" );

print "Content-type: text/html\n\n";

@now = localtime(time);

$cgiparams{'DAY'} = $now[3];
$cgiparams{'MONTH'} = $now[4];

&getcgihash(\%cgiparams);

&openpage('Smoothwall - Firewall log');
&openbigbox('100%', 'LEFT');

&openbox('100%', 'LEFT', 'Date:');

print "<FORM METHOD='POST'>\n";
print "<TABLE WIDTH='100%'>\n";
print "<TR>\n";
print "<TD>Month:</TD>\n";
print "<TD>\n";
print "<SELECT NAME='MONTH'>\n";
for ($month = 0; $month < 12; $month++)
{
	print "<OPTION ";
	if ($month == $cgiparams{'MONTH'}) {
		print 'SELECTED '; }
	print "VALUE='$month'>$longmonths[$month]\n";
}
print "</SELECT>\n";
print "</TD>\n";
print "<TD>Day:</TD>\n";

print "<TD>\n";
print "<SELECT NAME='DAY'>\n";
for ($day = 1; $day <= 31; $day++) 
{
	print "<OPTION ";
	if ($day == $cgiparams{'DAY'}) {
		print 'SELECTED '; }
	print "VALUE='$day'>$day\n";
}
print "</SELECT>\n";
print "</TD>\n";
print "<TD><INPUT TYPE='submit' NAME='ACTION' VALUE='Update'></TD>\n";
print "</TR>\n";
print "</TABLE>\n";
print "</FORM>\n";

&closebox();

$monthstr = $shortmonths[$cgiparams{'MONTH'}];
$day = $cgiparams{'DAY'};
if ($day <= 9) {
	$daystr = " $day"; }
else {
	$daystr = $day; }

&openbox('100%', 'LEFT', 'Firewall log:');
open (FILE, '/var/log/messages');
print "<TABLE WIDTH='100%'>\n";
print "<TR>\n";
print "<TD ALIGN='CENTER'><B>Time</B></TD>\n";
print "<TD ALIGN='CENTER'><B>Chain</B></TD>\n";
print "<TD ALIGN='CENTER'><B>Protocol</B></TD>\n";
print "<TD ALIGN='CENTER'><B>Source</B></TD>\n";
print "<TD ALIGN='CENTER'><B>Src Port</B></TD>\n";
print "<TD ALIGN='CENTER'><B>Destination</B></TD>\n";
print "<TD ALIGN='CENTER'><B>Dst Port</B></TD>\n";
print "</TR>\n";
print "<TR>\n";
while (<FILE>)
{
	if (/(^${monthstr} ${daystr} ..:..:..) \w+ kernel: Packet log: (.*)/)
	{
		$timestamp = $1; $packet = $2;
		$timestamp =~ /... (..) (..:..:..)/;
		$day = $1; $time = $2;

		if ($packet =~ /(\w+ - \w+) PROTO=(.*?) (.*?) (.*?) (.*)/)
		{
			$where = $1; $proto = $2; $src = $3; $dst = $4;
			$src =~ /([\d.]+):(\d+)/;
			$srcaddr = $1; $srcport = $2;
			$dst =~ /([\d.]+):(\d+)/;
			$dstaddr = $1; $dstport = $2;
			if ($proto == 6) { 
				$protostr = 'TCP'; }
			elsif ($proto == 17) {
				$protostr = 'UDP'; }
			else {
				$protostr = 'UNKNOWN'; }
			print "<TR>";
			print "<TD ALIGN='CENTER'>$time</TD>";
			print "<TD ALIGN='CENTER'>$where</TD>";
			print "<TD ALIGN='CENTER'>$protostr</TD>";
			print "<TD ALIGN='CENTER'>$srcaddr</TD>";
			print "<TD ALIGN='CENTER'>$srcport</TD>";
			print "<TD ALIGN='CENTER'>$dstaddr</TD>";
			print "<TD ALIGN='CENTER'>$dstport</TD>";
			print "</TR>\n";
		}
	}
}
close (FILE);
print "</TABLE>\n";
print "&nbsp;\n";
&closebox();

print <<END
<DIV ALIGN='CENTER'>
<TABLE WIDTH='60%'>
<TR><TD ALIGN='CENTER'>
<A HREF='/cgi-bin/index.cgi'>BACK</A>
</TD></TR></TABLE>
</DIV>
END
;

&closebigbox();

&closepage();
